Index: trunk/src/VBox/Frontends/VirtualBox/src/hostnetwork/UIHostNetworkDetailsDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/hostnetwork/UIHostNetworkDetailsDialog.cpp	(revision 67124)
+++ trunk/src/VBox/Frontends/VirtualBox/src/hostnetwork/UIHostNetworkDetailsDialog.cpp	(revision 67127)
@@ -252,4 +252,7 @@
 #endif
 
+            /* Get the required icon metric: */
+            const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
+
             /* Create automatic interface configuration layout: */
             QHBoxLayout *pLayoutAutomatic = new QHBoxLayout;
@@ -258,4 +261,5 @@
                 /* Configure layout: */
                 pLayoutAutomatic->setContentsMargins(0, 0, 0, 0);
+
                 /* Create automatic interface configuration radio-button: */
                 m_pButtonAutomatic = new QRadioButton;
@@ -275,5 +279,6 @@
                     m_pErrorPaneAutomatic->setAlignment(Qt::AlignLeft | Qt::AlignVCenter);
                     m_pErrorPaneAutomatic->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Minimum);
-                    m_pErrorPaneAutomatic->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneAutomatic->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                     .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutAutomatic->addWidget(m_pErrorPaneAutomatic);
@@ -309,5 +314,6 @@
                     m_pErrorPaneManual->setAlignment(Qt::AlignLeft | Qt::AlignVCenter);
                     m_pErrorPaneManual->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Minimum);
-                    m_pErrorPaneManual->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneManual->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                  .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutManual->addWidget(m_pErrorPaneManual);
@@ -352,5 +358,6 @@
                     /* Configure label: */
                     m_pErrorPaneIPv4->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneIPv4->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneIPv4->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutIPv4->addWidget(m_pErrorPaneIPv4);
@@ -392,5 +399,6 @@
                     /* Configure label: */
                     m_pErrorPaneNMv4->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneNMv4->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneNMv4->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutNMv4->addWidget(m_pErrorPaneNMv4);
@@ -432,5 +440,6 @@
                     /* Configure label: */
                     m_pErrorPaneIPv6->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneIPv6->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneIPv6->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutIPv6->addWidget(m_pErrorPaneIPv6);
@@ -472,5 +481,6 @@
                     /* Configure label: */
                     m_pErrorPaneNMv6->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneNMv6->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneNMv6->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutNMv6->addWidget(m_pErrorPaneNMv6);
@@ -520,4 +530,7 @@
 #endif
 
+            /* Get the required icon metric: */
+            const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
+
             /* Create DHCP server status check-box: */
             m_pCheckBoxDHCP = new QCheckBox;
@@ -566,5 +579,6 @@
                     /* Configure label: */
                     m_pErrorPaneDHCPAddress->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneDHCPAddress->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneDHCPAddress->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                       .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutDHCPAddress->addWidget(m_pErrorPaneDHCPAddress);
@@ -606,5 +620,6 @@
                     /* Configure label: */
                     m_pErrorPaneDHCPMask->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneDHCPMask->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneDHCPMask->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                    .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutDHCPMask->addWidget(m_pErrorPaneDHCPMask);
@@ -646,5 +661,6 @@
                     /* Configure label: */
                     m_pErrorPaneDHCPLowerAddress->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneDHCPLowerAddress->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneDHCPLowerAddress->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                            .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutDHCPLowerAddress->addWidget(m_pErrorPaneDHCPLowerAddress);
@@ -686,5 +702,6 @@
                     /* Configure label: */
                     m_pErrorPaneDHCPUpperAddress->setAlignment(Qt::AlignCenter);
-                    m_pErrorPaneDHCPUpperAddress->setPixmap(UIIconPool::iconSet(":/status_error_16px.png").pixmap(QSize(16, 16)));
+                    m_pErrorPaneDHCPUpperAddress->setPixmap(UIIconPool::iconSet(":/status_error_16px.png")
+                                                            .pixmap(QSize(iIconMetric, iIconMetric)));
                     /* Add into layout: */
                     pLayoutDHCPUpperAddress->addWidget(m_pErrorPaneDHCPUpperAddress);